Public Types | Public Member Functions

# ContactSearch Class Reference

This class encapsulates functionality for looking up contacts on the Skype network. Contacts can be searched by portion of their name, e-mail address, language preferences, etc. More...

`#include <skype-embedded_2.h>`

List of all members.

## Public Types
enum | { MODULE_ID = 1 }
enum | PROPERTY { P_CONTACT_SEARCH_STATUS = 200 }
enum | STATUS { CONSTRUCTION = 1, PENDING, EXTENDABLE, FINISHED, FAILED }
enum | CONDITION { EQ = 0, GT, GE, LT, LE, PREFIX_EQ, PREFIX_GE, PREFIX_LE, CONTAINS_WORDS, CONTAINS_WORD_PREFIXES }
typedef ContactSearchRef | Ref
typedef ContactSearchRefs | Refs
## Public Member Functions
virtual | ~ContactSearch ()
ContactSearchRef | ref ()
bool | AddMinAgeTerm (const uint &min_age_in_years, bool &valid, const bool add_to_subs=false)
bool | AddMaxAgeTerm (const uint &max_age_in_years, bool &valid, const bool add_to_subs=false)
bool | AddEmailTerm (const Sid::String &email, bool &valid, const bool add_to_subs=false)
bool | AddLanguageTerm (const Sid::String &language, bool &valid, const bool add_to_subs=false)
bool | AddStrTerm (const int &prop, const CONDITION &cond, const Sid::String &value, bool &valid, const bool add_to_subs=false)
bool | AddIntTerm (const int &prop, const CONDITION &cond, const uint &value, bool &valid, const bool add_to_subs=false)
bool | AddOr ()
bool | IsValid (bool &result)
bool | Submit ()
bool | Extend ()
bool | Release ()
bool | GetResults (ContactRefs &contacts, const uint from=0, const uint count=MAX_UINT)
virtual void | OnNewResult (const ContactRef &contact, const uint &rankValue)
bool | GetPropContactSearchStatus (STATUS &contact_search_status)

## Detailed Description

This class encapsulates functionality for looking up contacts on the Skype network. Contacts can be searched by portion of their name, e-mail address, language preferences, etc.

Contact search is asynchronous. ContactSearch::Submit is a non-blocking function that initiates the search. Upon finding a matching contact, ContactSearch::OnNewResult event gets fired, that gives you the reference to the discovered contact. You can get up to 100 matching contacts per search. Note that you will need to keep a live reference of the ContactSearch object while the search is doing its work.
So, to perform a contact search:

- create a contact search object
- specify search terms and conditions
- submit search
- in ContactSearch::OnNewResult callback, update your UI
- in ContactSearch::OnChange, check for terminal values of P_CONTACT_SEARCH_STATUS and update the UI accordingly.
  When the search has done its job, the ContactSearch::P_CONTACT_SEARCH_STATUS property will go to one of the terminal values.
  The terminal values are:
- FINISHED - the search has stopped. Note that this does not mean any matches were actually found.
- FAILED - the search has failed.
- EXTENDABLE - this state should be considered the same as FINISHED. The feature of extending long search results is about to be deprecated. It is still possible for search objects to occasionally reach that state, so it should be handled in the UI (as FINISHED), but the extending feature itself should not be implemented in your UI.
  There are three methods to create the ContactSearch objects.
  A) Skype::CreateIdentitySearch
  This method takes a string argument and looks for exact matches against Contact::P_SKYPENAME property. So for example, identity search for "echo" will return 0 results and search for "echo123" will return exactly one.
  Identity in this case means skypename - contact search does not work with PSTN type contacts. However, it does work for SKYPE type contacts that have supplied P_PHONE_HOME, P_PHONE_OFFICE or P_PHONE_MOBILE values in their account data. To search for those, you will need to use complex search (see below).
  Note that you should always check for boolean return value of the CreateIdentitySearch method. If the user submits a string that is not a valid skypename, the method will return false and the ContactSearchRef argument will return as NULL.
  B) Skype::CreateBasicContactSearch
  This method takes a string argument and looks for non-exact matches against both P_SKYPENAME and P_FULLNAME properties of the contact. If you intend to implement a simple, one-input search feature - this is the best method for you. The non-exact matching operates similarly to the SQL LIKE condition.
  C) Skype::CreateContactSearch
  This method enables you to implement advanced contact search, matching against multiple seach criteria. It takes no input arguments and expects search criteria to be added to the already constructed search object.
  Criteria can be added with ContactSearch::AddStrTerm and ContactSearch::AddIntTerm methods.
  These methods take Contact class porperty ID, condition, and the match pattern as inputs.
  Only the following Contact properties can be used for search:
- P_SKYPENAME
- P_FULLNAME
- P_BIRTHDAY (uint)
- P_GENDER (uint: 1-male, 2-female)
- P_LANGUAGES
- P_COUNTRY
- P_PROVINCE
- P_CITY
- P_PHONE_HOME
- P_PHONE_OFFICE
- P_PHONE_MOBILE
- P_EMAILS
- P_HOMEPAGE
- P_ABOUT
  String searches are case insensitive, i.e. search for echo123 also matches ECHO123
  When adding multiple criteria, default behaviour is that the criterions are additive. I.e. a term skypename == "joe" followed by term country == "us" will result in intersection between all joes and everybody in US.
  You can explicitly add an "OR" instead of "AND" between conditions, using the AddOr method.
  By default, AND criteria are grouped together, before OR's, so that:
  AddTerm(condition1)
  AddTerm(condition2)
  AddOr()
  AddTerm(condition3)
  AddTerm(condition4)
  will result in the following logical statement:
  (condition1 AND condition2) OR (condition3 AND condition4)
  However, you can add "global" critera, by using the add_to_subs argument of the AddXX methods.
  AddTerm(condition1)
  AddTerm(condition2)
  AddOr()
  AddTerm(condition3)
  AddTerm(condition4, add_to_subs=true)
  which would result in:
  (condition1 AND condition2 AND condition4) OR (condition3 AND condition4)
  Every one of the contact properties can only be used once, per search. For example, you cannot create a search for two different P_FULLNAME patterns. The &valid argument will still return tue if you do this, but the last criteria for any given property will override all previous ones. So, a search like this:
  cs->AddStrTerm(Contact::P_FULLNAME, ContactSearch::EQ, "John Smith", isValid);
  cs->AddOr();
  cs->AddStrTerm(Contact::P_FULLNAME, ContactSearch::EQ, "Ivan Sidorov", isValid);
  will only return matches for "Ivan Sidorov" and none for "John Smith".
  Some of the contact properties are automatically combined for purposes of search.
  A search for P_SKYPENAME also returns matches from the P_FULLNAME property and vice versa.
  So that this:
  cs->AddStrTerm(Contact::P_SKYPENAME, ContactSearch::EQ, "john.smith", isValid);
  ..and this:
  cs->AddStrTerm(Contact::P_FULLNAME, ContactSearch::EQ, "John Smith", isValid);
  ..and this:
  cs->AddStrTerm(Contact::P_SKYPENAME, ContactSearch::EQ, "john.smith", isValid);
  cs->AddOr();
  cs->AddStrTerm(Contact::P_FULLNAME, ContactSearch::EQ, "John Smith", isValid);
  ..all search from both the P_FULLNAME and P_SKYPENAME fields.
  Before using ContactGroup::Submit to start the search, you should always check whether the search criteria ended up being valid. This you can do with ContactSearch::IsValid method.
  As you probably noticed, each of the AddXX methods also return a validity check boolean. However, it is a better practice to do the overall check as well, even if all the individual search criteria ended up looking Ok.
  For example, lets take a search for contact's e-mail. This can be done with two different methods. Firstly we can use the ContactSearch::AddEmailTerm method. This method will actually validate whether the input is a valid e-mail address:
  cs->AddEmailTerm ("test@test@test", isValid);
  will return the isValid argument as false.
  However, you can also add the e-mail search criterion as a simple string, like this:
  cs->AddStrTerm(Contact::P_EMAILS, ContactSearch::EQ, "test@test@test@", isValid);
  in which case the isValid will return true.
  However, if you then check entire search object with:
  cs->IsValid(isValid);
  the isValid will correctly return false.

Definition at line 652 of file skype-embedded_2.h.

## Member Typedef Documentation

typedef ContactSearchRef ContactSearch::Ref

Definition at line 661 of file skype-embedded_2.h.

typedef ContactSearchRefs ContactSearch::Refs

Definition at line 662 of file skype-embedded_2.h.

## Member Enumeration Documentation

anonymous enum

Enumerator:

  MODULE_ID |

Definition at line 663 of file skype-embedded_2.h.

enum ContactSearch::CONDITION

List of available matching conditions that can be used in AddTerm methods.

Enumerator:

  EQ | Equals
  GT | Is greater than
  GE | Is greater or equal.
  LT | Is less than
  LE | Less or equal
  PREFIX_EQ | Start of a word macthes exactly (string properties only).
  PREFIX_GE | Start of a word is greater or equal (string properties only).
  PREFIX_LE | Start of a word is less or equal (string properties only).
  CONTAINS_WORDS | Contains the word (string properties only).
  CONTAINS_WORD_PREFIXES | One of the words starts with searched value (string properties only).

Definition at line 718 of file skype-embedded_2.h.

enum ContactSearch::PROPERTY

Properties of the ContactSearch class

Enumerator:

  P_CONTACT_SEARCH_STATUS | type: STATUS

Definition at line 677 of file skype-embedded_2.h.

enum ContactSearch::STATUS

Possible values for the ContactSearch.P_STATUS property.

Enumerator:

  CONSTRUCTION | Transient state, obtained after submission and actually initiating the search on the network.
  PENDING | Waiting for results to show up. This is a transient state.
  EXTENDABLE | Enough matches are found. No more OnNewResult events will fire. The feature of extending long search results is about to be deprecated. It is still possible for search objects to occasionally reach that state, so it should be handled in the UI (as FINISHED), but the extending feature itself should not be implemented in your UI.
  FINISHED | The search is finished. No more matches are expected. This is a terminal state.
  FAILED | ContactSearch failed. Better check if the search terms made any sense, with ContactSearch::IsValid. This is a terminal state.

Definition at line 682 of file skype-embedded_2.h.

## Constructor & Destructor Documentation

ContactSearch::~ContactSearch | ( |  | ) | `[virtual]`

Definition at line 279 of file skype-embedded_2.cpp.

## Member Function Documentation

bool ContactSearch::AddEmailTerm | ( | const Sid::String & | email,
|  | bool & | valid,
|  | const bool | add_to_subs = `false` |
| ) |  |  |

Adds a search term against Contact::P_EMAILS property and pre-validates the value given in the email argument.

Parameters:

  | email | e-mail addres to search for.
  | valid | Returns false if the value in email property did not look like a valid email address.
  | add_to_subs | This argument enables you to group conditions. See ContactSearch class details for more information.

bool ContactSearch::AddIntTerm | ( | const int & | prop,
|  | const CONDITION & | cond,
|  | const uint & | value,
|  | bool & | valid,
|  | const bool | add_to_subs = `false` |
| ) |  |  |

Adds a search term to a custom contact search object. For now, there are only two searchable Contact properties that are integers, so this can oly be used for Contact::P_BIRTHDAY and Contact::P_GENDER.

Parameters:

  | prop | Propkey to search for. Either Contact::P_BIRTHDAY or Contact::P_GENDER
  | cond | Search condition (ContactSearch::CONDITION)
  | value | Value to match against.
  | valid | Returns true if the ContactSearch term-set remains valid after adding this term.
  | add_to_subs | This argument enables you to group conditions. See ContactSearch class details for more information.

bool ContactSearch::AddLanguageTerm | ( | const Sid::String & | language,
|  | bool & | valid,
|  | const bool | add_to_subs = `false` |
| ) |  |  |

bool ContactSearch::AddMaxAgeTerm | ( | const uint & | max_age_in_years,
|  | bool & | valid,
|  | const bool | add_to_subs = `false` |
| ) |  |  |

construct CONTACT_BIRTHDAY term based on current time

bool ContactSearch::AddMinAgeTerm | ( | const uint & | min_age_in_years,
|  | bool & | valid,
|  | const bool | add_to_subs = `false` |
| ) |  |  |

construct CONTACT_BIRTHDAY term based on current time

bool ContactSearch::AddOr | ( |  | ) |

used to group terms (AddTerm(1), AddTerm(2), Or(), AddTerm(3), AddTerm(4), etc)

bool ContactSearch::AddStrTerm | ( | const int & | prop,
|  | const CONDITION & | cond,
|  | const Sid::String & | value,
|  | bool & | valid,
|  | const bool | add_to_subs = `false` |
| ) |  |  |

Adds a string search term to a custom contact search object.

Parameters:

  | prop | Following Contact class string propkeys can be used for Contact search: Contact::P_SKYPENAME Contact::P_FULLNAME Contact::P_LANGUAGES Contact::P_COUNTRY Contact::P_PROVINCE Contact::P_CITY Contact::P_PHONE_HOME Contact::P_PHONE_OFFICE Contact::P_PHONE_MOBILE Contact::P_EMAILS Contact::P_HOMEPAGE Contact::P_ABOUT Note that while Contact::P_EMAILS is technically a string and can be used in this method, it is recommended that you use ContactSearch.AddEmailTerm method instead.
  | cond | Search condition (ContactSearch::CONDITION)
  | value | Value to match against.
  | valid | Returns true if the ContactSearch term-set remains valid after adding this term.
  | add_to_subs | This argument enables you to group conditions. See ContactSearch class details for more information.

bool ContactSearch::Extend | ( |  | ) |

extend if search is EXTENDABLE

bool ContactSearch::GetPropContactSearchStatus | ( | STATUS & | contact_search_status | ) |

ContactSearch::P_CONTACT_SEARCH_STATUS property get accessor

bool ContactSearch::GetResults | ( | ContactRefs & | contacts,
|  | const uint | from = `0`,
|  | const uint | count = `MAX_UINT` |
| ) |  |  |

result list is dynamically updated

bool ContactSearch::IsValid | ( | bool & | result | ) |

checks that terms list is non-empty and does not contain unsupported keys

virtual void ContactSearch::OnNewResult | ( | const ContactRef & | contact,
|  | const uint & | rankValue |
| ) |  |  | `[virtual]`

This callback is fired when a new matching contact has been found during the search.

ContactSearchRef ContactSearch::ref | ( |  | ) | `[inline]`

Definition at line 664 of file skype-embedded_2.h.

bool ContactSearch::Release | ( |  | ) |

releases results that are not referenced from elsewhere

bool ContactSearch::Submit | ( |  | ) |

launch search

The documentation for this class was generated from the following files:

- skype-embedded_2.h
- skype-embedded_2.cpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines

(c) Skype Technologies S.A. Confidential/Proprietary

Last updated: Fri Mar 16 2012